import { WaiterConfiguration, WaiterResult } from "@smithy/util-waiter";
import { DescribeProjectVersionsCommandInput } from "../commands/DescribeProjectVersionsCommand";
import { RekognitionClient } from "../RekognitionClient";
/**
 * Wait until the ProjectVersion is running.
 *  @deprecated Use waitUntilProjectVersionRunning instead. waitForProjectVersionRunning does not throw error in non-success cases.
 */
export declare const waitForProjectVersionRunning: (params: WaiterConfiguration<RekognitionClient>, input: DescribeProjectVersionsCommandInput) => Promise<WaiterResult>;
/**
 * Wait until the ProjectVersion is running.
 *  @param params - Waiter configuration options.
 *  @param input - The input to DescribeProjectVersionsCommand for polling.
 */
export declare const waitUntilProjectVersionRunning: (params: WaiterConfiguration<RekognitionClient>, input: DescribeProjectVersionsCommandInput) => Promise<WaiterResult>;
